
#include once "bipipe.bi"
' https://www.freebasic-portal.de/code-beispiele/kleine-helferlein/bipipe-bi-297.html
' https://www.freebasic-portal.de/code-beispiele/kleine-helferlein/bipipe-bi-fuer-win-linux-299.html

#ifdef __FB_UNIX__
const EOL as string = chr(10)
#else
const EOL as string = chr(13, 10)
#endif

dim shared as any ptr process

function Connect(aUciEngine as const string) as boolean
  dim s as string = aUciEngine
  process = bipOpen(s)
  return true
end function

sub SendCommand(aUciCommand as const string)
  bipWrite(process, aUciCommand & EOL)
end sub

function ReadEngineOutput as string
  return bipRead(process)
end function

sub Disconnect
  bipClose(process)
end sub
