namespace sGUI

declare function AddBMPSimpleGadget (event as EventHandle ptr,PosX as integer,PosY as integer,fus as string,fs as string="",fm as string="") as Gadget ptr
declare function BMPSGActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawBMPSimpleGadget (gad as Gadget ptr)

function AddBMPSimpleGadget (event as EventHandle ptr,PosX as integer,PosY as integer,fus as string,fs as string="",fm as string="") as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    dim as integer GadWidth,GadHeight,ff=freefile
    open  fus for binary as #ff
      get #ff, 19, GadWidth
      get #ff, 23, GadHeight
    close #ff
    gad->event=event
  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    gad->gadw=GadWidth
    gad->gadh=GadHeight

    gad->DoDraw     =@DrawBMPSimpleGadget
    gad->DoAction   =@BMPSGActions
    gad->DoUpdate   =@DrawBMPSimpleGadget

    if fm>"" then
      gad->Mask=imagecreate(GadWidth,GadHeight)
      bload fm,gad->Mask
    end if

    if fus>"" then
      gad->Unselected=imagecreate(GadWidth,GadHeight)
      bload fus,gad->Unselected
    end if

    if fs>"" then
      gad->Selected=imagecreate(GadWidth,GadHeight)
      bload fs,gad->Selected
    end if

    gad->SaveBackGround
    function=gad
  end if
end function



function BMPSGActions(gad as Gadget ptr,action as integer) as integer
  function=0
  select case action
      
      case GADGET_HIT        'Control grad frisch gedrckt
        SetSelect (gad,1)
      
      case GADGET_HOLD       'Control wird gehalten, Maus ber dem Control
        SetSelect (gad,1)
      
      case GADGET_HOLDOFF    'Control wird gehalten, Maus neben dem Control
        SetSelect (gad,0)
      
      case GADGET_RELEASE    'Control regulr losgelassen
        SetSelect (gad,0)
        function=1           'Ping!!!! Control meldet sich: bei mir ist was passiert!!!
      
      case GADGET_RELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control
        SetSelect (gad,0)
  
  end select
end function



sub DrawBMPSimpleGadget (gad as Gadget ptr)
	dim as integer PosX,PosY,GadWidth,GadHeight
  PosX   =gad->posx
	PosY   =gad->posy
	GadWidth		=gad->gadw
	GadHeight		=gad->gadh
  if listener <> 0 then mutexlock(listener->sync)
  screenlock
	if gad->act=0 then 
    put(PosX,PosY),gad->Background,trans
  else
		put(PosX,PosY),gad->Background,trans
		if (gad->sel=1) and (gad->Selected>0) then
		  put(PosX,PosY),gad->Selected,trans
		else
			put(PosX,PosY),gad->Unselected,trans
  	end if
    if gad->act=2 then put(PosX,PosY),gad->Background,alpha,SleepShade
	end if
  screenunlock
  if listener <> 0 then mutexunlock(listener->sync)
end sub

end namespace
