#include once "MiniSelector.bas"
#include once "ComboArrowDwn.bas"
#include once "ComboBox_Basis.bas"

namespace sGUI

declare function AddComboBox(event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer, NumRows as integer=5) as Gadget ptr
declare function ComboBoxActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawComboBox (gad as Gadget ptr)
declare sub SetComboBoxVal(gad as Gadget ptr,i as integer)
declare function GetComboBoxVal(gad as Gadget ptr) as integer

'Ctrl(0)  Breite in Zeichen
'Ctrl(1)  Hhe in Zeichen
'Ctrl(14) Vergleichsreferenz zu Ctrl(15)
'Ctrl(15) selektiertier Eintrag
function AddComboBox(event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer, NumRows as integer=5) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    gad->gadw=NumChars*8 + 6 + 15
    gad->gadh=fontheight + 6 '6 >> Rand innerhalb MLEB

    gad->Ctrl(0)=NumChars
    gad->Ctrl(1)=NumRows
    
    gad->subevent=new EventHandle
    if gad->subevent then
      gad->gad(0)=AddCBox (gad->subevent,PosX,PosY,NumChars)
    	gad->gad(1)=AddArrowDwn(gad->subevent,PosX + NumChars*8 + 6,PosY)
		end if

    gad->extTObject=gad->gad(0)->TObject'Verbindung zum Textobjekt erzeugen das eigentlich zur LB in gad(0) gehrt
    gad->useextTO=1                     'Flag fr alle TO-Befehle extTObject zu benutzen

    gad->DoDraw     =@DrawComboBox
    gad->DoAction   =@ComboBoxActions
    gad->DoUpdate   =@DrawComboBox

		'gad->SaveBackGround
		function=gad
  end if
end function



function ComboBoxActions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as integer result
  select case action
    'case GADGET_HIT,GADGET_HOLD,GADGET_HOLDOFF,GADGET_RELEASE,GADGET_RELEASEOFF
    case GADGET_HIT,GADGET_HOLD,GADGET_RELEASE
    gad->subevent->GadgetControl
      gad->Ctrl(14)=gad->Ctrl(15)
      if gad->subevent->GADGETMESSAGE then
        select case gad->subevent->GADGETMESSAGE
          'case gad->gad(0)
            'nichts
          case gad->gad(0),gad->gad(1)
            result=MiniSelector(gad->posx,gad->posy + Fontheight+6 ,gad->Ctrl(0),gad->Ctrl(1),GetTOAddress(gad->gad(0)),gad->Ctrl(15))
            if result then
              gad->Ctrl(15)=result
              gad->gad(0)->Ctrl(15)=result
            end if
        end select
      end if
      if gad->Ctrl(14)<>gad->Ctrl(15) then
        UpdateGadget(gad)
        function=1
      end if
  end select
end function




sub DrawComboBox (gad as Gadget ptr)
  DrawGadget(gad->gad(0))
end sub



sub SetComboBoxVal(gad as Gadget ptr,i as integer)
  dim as integer l
  l=TO_GetLines(gad)
  if i<1 then i=1
  if i>l then i=l
  gad->gad(0)->Ctrl(15)=i
  gad->Ctrl(15)=i
  DrawGadget(gad)
end sub



function GetComboBoxVal(gad as Gadget ptr) as integer
  function=gad->Ctrl(15)
end function

end namespace
